package ORG.omg.CORBA;


import ORG.omg.CORBA.*;
import EDU.rutgers.CORBA.IOP.IOR;
import EDU.rutgers.CORBA.clntsrv.PortableServer.ObjectReference;
import EDU.rutgers.act.presentation.TypeWriter;
import EDU.rutgers.act.presentation.TypeReader;

public abstract class _InitialReferencesImplBase
  extends EDU.rutgers.CORBA.clntsrv.PortableServer.Skeleton
  implements InitialReferences
{
  public boolean _is_a(
          String logicalTypeId
  )
    {
      return true;
    }

  protected void _is_aInvoke(TypeReader in, TypeWriter out)
    {
      String logicalTypeId = null;
      IOR ior;
      try
	{
          logicalTypeId = in.readString();
          boolean result = _is_a(logicalTypeId);
          out.writeBoolean(result);
          out.flush();
        }
      catch(java.io.IOException e)
        {
          System.out.println("Marshaling/unmarshaling error: " + e);
          System.exit(1);
        }
    }

  public abstract String get(
          String id
  );

  protected void getInvoke(TypeReader in, TypeWriter out)
    {
      String id = null;
      IOR ior;
      try
	{
          id = in.readString();
          String result = get(id);
          out.writeString(result);
          out.flush();
        }
      catch(java.io.IOException e)
        {
          System.out.println("Marshaling/unmarshaling error: " + e);
          System.exit(1);
        }
    }

  public abstract String[] list(
  );

  protected void listInvoke(TypeReader in, TypeWriter out)
    {
      IOR ior;
      try
	{
          String[] result = list();
          out.writeULong(result.length);
          for(int ObjectIdListInd = 0; ObjectIdListInd < result.length; ObjectIdListInd++)
            {
              out.writeString(result[ObjectIdListInd]);
            }
          out.flush();
        }
      catch(java.io.IOException e)
        {
          System.out.println("Marshaling/unmarshaling error: " + e);
          System.exit(1);
        }
    }

  protected void callMethod(String operation,
                            TypeReader in,
                            TypeWriter out)
    {
      if(operation.compareTo("_is_a") == 0)
        {
           _is_aInvoke(in, out);
        }
      else
      if(operation.compareTo("get") == 0)
        {
           getInvoke(in, out);
        }
      else
      if(operation.compareTo("list") == 0)
        {
           listInvoke(in, out);
        }
      else
        { // the operation does not match any operation in this object!
          // send an exception here, but not implemented yet
          System.out.println("Unknown operation!");
        }
    }
}