      // get a socket somehow, for example:
      Socket socket_ = srv.accept;

      MessageFactory factory_ = new GIOPMessageFactory();
      Reader reader_ = new InputStreamReader(socket_.getInputStream());
      TypeReader typeReader =
	TransferSyntaxFactory.createTypeReader("CDR", reader_);
      Message m = factory_.createFromStream(typeReader);
      //
      // m now contains the message read from the Inputstream
      // suppose m is a reply. Then cast it:

      GIOPReplyMessage reply = (GIOPReplyMessage)m;

      //
      // create the type reader for getting the content of the body
      //
      ByteArrayInputStream stream = 
	new ByteArrayInputStream(reply.getReplyBody());
      TypeReader in = TransferSyntaxFactory.createTypeReader(
			 "CDR", 
			 new InputStreamReader(stream));

      in.setIndex(reply.getBeforeBodySize());
      in.setByteOrder(reply.byte_order_);


      //
      // read the data inside the body of the Reply message
      //
      try {
        boolean b = in.readBoolean();
        int i = in.readULong();
        // ...
        // read primitive types of data using TypeReader primitives
      }
      catch(java.io.IOException e)
      {
        System.out.println("Marshaling/unmarshaling error: " + e);
        System.exit(1);
      }
