      //
      // Compose the Request message
      //

      byte[] context_data = "".getBytes();
      ServiceContext[] service_context = new ServiceContext[0];

      for (int i = 0; i < service_context.length; i ++)
	{
	  service_context[i] = new ServiceContext(1, context_data);
        }

      // !!!!
      int requestId = 1 // put the request ID here, unique ints will do; 
      boolean response_expected = true;
      Principal requesting_principal = new Principal("some string".getBytes());
      request_ =
	new GIOPRequestMessage(service_context, 
			       requestId, 
			       response_expected, 
			       objectKey, 
			       operation, 
			       requesting_principal);

      //
      // compose the body of the message
      //
      bodyStream_ = new ByteArrayOutputStream();
      outWriter_ = TransferSyntaxFactory.createTypeWriter("CDR", 
            new OutputStreamWriter(bodyStream_));
      outWriter_.setByteOrder(request_.byte_order_); // inherited

      // aligned with the GIOP header
      outWriter_.setIndex(request_.getBeforeBodySize()); 

      //
      // start writing the data inside
      //
      try
	{
          // write data inside the body using CDR primitives, e.g.:
          outWriter_.writeString("a string");
          // ... use other primitives as you wish...

	  outWriter_.flush();

	  // write to the body
	  byte[] bodyBytes;

	  bodyBytes = bodyStream_.toByteArray();
	  request_.setRequestBody(bodyBytes);
        }
      catch (java.io.IOException e)
	{
	  System.err.println("Error composing Request Message");
	  System.exit(1);
        }


      // 
      // send the message 
      //
      request_.setEndpoint(new Endpoint(profile_.host_, 
					0x0000FFFF & profile_.port_));


      // obtaing a socket somehow
      Socket socket = new Socket("host", 9000);

      Writer writer = new OutputStreamWriter(socket.getOutputStream());
      TypeWriter typeWriter =
	TransferSyntaxFactory.createTypeWriter(encoding_, writer);
      message.write(typeWriter);
      typeWriter.flush();

      // the message is now sent!
